//--------------------------------------------------------------
// VocalShifter - VSLIB
//--------------------------------------------------------------
#ifndef _VSLIB_H_
#define _VSLIB_H_

#ifdef _WIN64
	#pragma comment( lib, "vslib_x64.lib" )
#else
	#pragma comment( lib, "vslib.lib" )
#endif

#ifdef __cplusplus
#define VSLIB_IMPORT extern "C" __declspec(dllimport)
#else
#define VSLIB_IMPORT __declspec(dllimport)
#endif

//--------------------------------------------------------------
// }N`
//--------------------------------------------------------------
#define VSLIB_MAX_PATH		(256)
#define VSLIB_MAX_TRACK		(64)	// gbNő吔
#define VSLIB_MAX_ITEM		(1024)	// ACeő吔

// G[R[h
#define VSERR_NOERR			(0)		// G[Ȃ
#define VSERR_PRM			(1)		// p[^s
#define VSERR_PRJOPEN		(2)		// PRJt@CI[vɎs
#define VSERR_PRJFORMAT		(3)		// PRJt@CtH[}bgs
#define VSERR_WAVEOPEN		(4)		// WAVEt@CI[vɎs
#define VSERR_WAVEFORMAT	(5)		// WAVEt@CtH[}bgs
#define VSERR_FREQ			(6)		// TvOgs
#define VSERR_MAX			(7)		// ő吔
#define VSERR_NOMEM			(8)		// s

// 
#define SYNTHMODE_M			(0)		// P
#define SYNTHMODE_MF		(1)		// PtH}g␳
#define SYNTHMODE_P			(2)		// a

// ̓IvV
#define ANALYZE_OPTION_SKIP_PIT_ANALYZE		(0x00000001)	// PIT͂XLbv
#define ANALYZE_OPTION_WORLD				(0x00000000)	// WORLD
#define ANALYZE_OPTION_VOCAL_SHIFTER		(0x00000002)	// VocalShifter

// nh`
typedef struct HVSPRJ__ { int unused; } *HVSPRJ;

// ASAnalyzer `l
#define AS_CH_LPR			(0)
#define AS_CH_LMR			(1)
#define AS_CH_L				(2)
#define AS_CH_R				(3)

// ASAnalyzer G[R[h
#define AS_ERR_NOERR		(0)
#define AS_ERR_NOMEM		(1)
#define AS_ERR_BADPRM		(2)
#define AS_ERR_OPEN			(3)
#define AS_ERR_FROMAT		(4)


//--------------------------------------------------------------
// \̒`
//--------------------------------------------------------------

// vWFNg
typedef struct{
	double masterVolume;	// (R/W) }X^[{[[{]
	int sampFreq;			// (R/W) TvOg[Hz]
} VSPRJINFO;

// gbN
typedef struct{
	double volume;			// (R/W) {[[{]
	double pan;				// (R/W) p(-1.0`1.0)
	int invPhaseFlg;		// (R/W) ttO
	int soloFlg;			// (R/W) \tO
	int muteFlg;			// (R/W) ~[gtO
} VSTRACKINFO;

// gbN(EX)
typedef struct{
	char name[64];			// (R/W) gbN
	double volume;			// (R/W) {[[{]
	double pan;				// (R/W) p(-1.0`1.0)
	double reserved1[2];	// \
	int invPhaseFlg;		// (R/W) ttO
	int soloFlg;			// (R/W) \tO
	int muteFlg;			// (R/W) ~[gtO
	int color;				// (R/W) gbNJ[
	int morphGroup;			// (R/W) [tBOO[v
	unsigned int option;	// (R/W) gbNIvV
	int reserved2[10];		// \
} VSTRACKINFOEX;

// ACe
typedef struct{
	char fileName[VSLIB_MAX_PATH];	// (R/-) t@C
	int sampFreq;			// (R/-) TvOg[Hz]
	int channel;			// (R/-) `l
	int sampleOrg;			// (R/-) IWỉt@C̃Tv
	int sampleEdit;			// (R/-) ҏW̃Tv
	int ctrlPntPs;			// (R/-) 1b̐_
	int ctrlPntNum;			// (R/-) S_
	int synthMode;			// (R/W) 
	int trackNum;			// (R/W) gbNԍ
	int offset;				// (R/W) ItZbg[sample]
} VSITEMINFO;

// ACe_
typedef struct{
	double dynOrg;			// (R/-) ҏWO_Ci~NX[{]
	double dynEdit;			// (R/W) ҏW_Ci~NX[{]
	double volume;			// (R/W) {[[{]
	double pan;				// (R/W) p(-1.0`1.0)
	double spcDyn;			// (R/-) XyNg_Ci~NX
	int pitAna;				// (R/-) sb`͒l[cent]
	int pitOrg;				// (R/W) ҏWOsb`[cent]
	int pitEdit;			// (R/W) ҏWsb`[cent]
	int formant;			// (R/W) tH}g[cent]
	int pitFlgOrg;			// (R/-) ҏWOsb`LtO
	int pitFlgEdit;			// (R/W) ҏWsb`LtO
	int breathiness;		// (R/W) uVlX[-10000`10000]
	int eq1;				// (R/W) EQ1[-10000`10000]
	int eq2;				// (R/W) EQ2[-10000`10000]
} VSCPINFOEX;

// ACe_2
typedef struct{
	double dynOrg;			// (R/-) ҏWO_Ci~NX[{]
	double dynEdit;			// (R/W) ҏW_Ci~NX[{]
	double volume;			// (R/W) {[[{]
	double pan;				// (R/W) p(-1.0`1.0)
	double spcDyn;			// (R/-) XyNg_Ci~NX
	double reserved1;		// \
	int pitAna;				// (R/-) sb`͒l[cent]
	int pitOrg;				// (R/W) ҏWOsb`[cent]
	int pitEdit;			// (R/W) ҏWsb`[cent]
	int formant;			// (R/W) tH}g[cent]
	int pitFlgOrg;			// (R/-) ҏWOsb`LtO
	int pitFlgEdit;			// (R/W) ҏWsb`LtO
	int breathiness;		// (R/W) uVlX[-10000`10000]
	int eq1;				// (R/W) EQ1[-10000`10000]
	int eq2;				// (R/W) EQ2[-10000`10000]
	int heq;				// (R/W) HEQ[-10000`10000]
	int reserved2[6];		// \
} VSCPINFOEX2;

// ASAnalyzer AWDINFO\
typedef struct{
	int wavdatasize;	// f[^̃TCY[Tv]
	int wavsampleps;	// TvOg[Hz]
	int wavbit;			// rbg(8or16)
	int wavchannel;		// `l(1or2)
	int nnoffset;		// ͂Œቹ[m[gio[]
	int nnrange;		// ͂鉹K͈̔[]
	int blockpn;		// ̃ubN(1-20)
	int dynsize;		// ʌo[Tv]
	int targetch;		// Ώۂ̃`l
} AWDINFO;


//--------------------------------------------------------------
// vg^Cv錾
//--------------------------------------------------------------

// Cu
VSLIB_IMPORT int __stdcall VslibGetVersion( void );

// vWFNg
VSLIB_IMPORT int __stdcall VslibCreateProject( HVSPRJ *hVsprj );
VSLIB_IMPORT int __stdcall VslibOpenProject( HVSPRJ *hVsprj, const char *fileName );
VSLIB_IMPORT int __stdcall VslibSaveProject( HVSPRJ hVsprj, const char *fileName );
VSLIB_IMPORT int __stdcall VslibDeleteProject( HVSPRJ hVsprj );
VSLIB_IMPORT int __stdcall VslibGetProjectInfo( HVSPRJ hVsprj, VSPRJINFO *vsPrjInfo );
VSLIB_IMPORT int __stdcall VslibSetProjectInfo( HVSPRJ hVsprj, VSPRJINFO *vsPrjInfo );

// gbN
VSLIB_IMPORT int __stdcall VslibGetTrackMaxNum( HVSPRJ hVsprj, int *trackMaxNum );
VSLIB_IMPORT int __stdcall VslibAddTrack( HVSPRJ hVsprj );
VSLIB_IMPORT int __stdcall VslibCopyTrack( HVSPRJ hVsprjDst, int *trackNumDst, HVSPRJ hVsprjSrc, int trackNumsrc );
VSLIB_IMPORT int __stdcall VslibUpTrack( HVSPRJ hVsprj, int trackNum );
VSLIB_IMPORT int __stdcall VslibDownTrack( HVSPRJ hVsprj, int trackNum );
VSLIB_IMPORT int __stdcall VslibDeleteTrack( HVSPRJ hVsprj, int trackNum );
VSLIB_IMPORT int __stdcall VslibGetTrackInfo( HVSPRJ hVsprj, int trackNum, VSTRACKINFO *vsTrackInfo );
VSLIB_IMPORT int __stdcall VslibSetTrackInfo( HVSPRJ hVsprj, int trackNum, VSTRACKINFO *vsTrackInfo );
VSLIB_IMPORT int __stdcall VslibGetTrackInfoEx( HVSPRJ hVsprj, int trackNum, VSTRACKINFOEX *vsTrackInfo );
VSLIB_IMPORT int __stdcall VslibSetTrackInfoEx( HVSPRJ hVsprj, int trackNum, VSTRACKINFOEX *vsTrackInfo );

// ACe
VSLIB_IMPORT int __stdcall VslibGetItemMaxNum( HVSPRJ hVsprj, int *itemMaxNum );
VSLIB_IMPORT int __stdcall VslibAddItem( HVSPRJ hVsprj, const char *fileName, int *itemNum );
VSLIB_IMPORT int __stdcall VslibAddItemEx( HVSPRJ hVsprj, const char *fileName, int *itemNum,
									int nnOffset, int nnRange, unsigned int option );
VSLIB_IMPORT int __stdcall VslibCopyItem( HVSPRJ hVsprjDst, int *itemNumDst, HVSPRJ hVsprjSrc, int itemNumSrc );
VSLIB_IMPORT int __stdcall VslibDeleteItem( HVSPRJ hVsprj, int itemNum );
VSLIB_IMPORT int __stdcall VslibGetItemInfo( HVSPRJ hVsprj, int itemNum, VSITEMINFO *vsItemInfo );
VSLIB_IMPORT int __stdcall VslibSetItemInfo( HVSPRJ hVsprj, int itemNum, VSITEMINFO *vsItemInfo );
VSLIB_IMPORT int __stdcall VslibGetCtrlPntInfoEx( HVSPRJ hVsprj, int itemNum, int pntNum, VSCPINFOEX *vsCpInfo );
VSLIB_IMPORT int __stdcall VslibSetCtrlPntInfoEx( HVSPRJ hVsprj, int itemNum, int pntNum, VSCPINFOEX *vsCpInfo );
VSLIB_IMPORT int __stdcall VslibGetCtrlPntInfoEx2( HVSPRJ hVsprj, int itemNum, int pntNum, VSCPINFOEX2 *vsCpInfo2 );
VSLIB_IMPORT int __stdcall VslibSetCtrlPntInfoEx2( HVSPRJ hVsprj, int itemNum, int pntNum, VSCPINFOEX2 *vsCpInfo2 );

VSLIB_IMPORT int __stdcall VslibGetEQGain( HVSPRJ hVsprj, int itemNum, int eqNum, int *gain );
VSLIB_IMPORT int __stdcall VslibSetEQGain( HVSPRJ hVsprj, int itemNum, int eqNum, int *gain );
VSLIB_IMPORT int __stdcall VslibGetHEQGain( HVSPRJ hVsprj, int itemNum, int *gain );
VSLIB_IMPORT int __stdcall VslibSetHEQGain( HVSPRJ hVsprj, int itemNum, int *gain );

// ^C~O
VSLIB_IMPORT int __stdcall VslibGetTimeCtrlPntNum( HVSPRJ hVsprj, int itemNum, int *timeCtrlPntNum );
VSLIB_IMPORT int __stdcall VslibGetTimeCtrlPnt( HVSPRJ hVsprj, int itemNum, int pntNum, int *time1, int *time2 );
VSLIB_IMPORT int __stdcall VslibSetTimeCtrlPnt( HVSPRJ hVsprj, int itemNum, int pntNum, int time1, int time2 );
VSLIB_IMPORT int __stdcall VslibAddTimeCtrlPnt( HVSPRJ hVsprj, int itemNum, int time1, int time2 );
VSLIB_IMPORT int __stdcall VslibDeleteTimeCtrlPnt( HVSPRJ hVsprj, int itemNum, int pntNum );

VSLIB_IMPORT int __stdcall VslibGetStretchOrgSec( HVSPRJ hVsprj, int itemNum, double time_edt, double *time_org );
VSLIB_IMPORT int __stdcall VslibGetStretchEditSec( HVSPRJ hVsprj, int itemNum, double time_org, double *time_edt );
VSLIB_IMPORT int __stdcall VslibGetStretchOrgSample( HVSPRJ hVsprj, int itemNum, double time_edt, double *time_org );
VSLIB_IMPORT int __stdcall VslibGetStretchEditSample( HVSPRJ hVsprj, int itemNum, double time_org, double *time_edt );

// ~LT[
VSLIB_IMPORT int __stdcall VslibGetMixSample( HVSPRJ hVsprj, int *mixSample );
VSLIB_IMPORT int __stdcall VslibGetMixData( HVSPRJ hVsprj, void *waveData, int bit, int channel, int index, int size );
VSLIB_IMPORT int __stdcall VslibExportWaveFile( HVSPRJ hVsprj, const char *fileName, int bit, int channel );

// Pʕϊ
VSLIB_IMPORT double __stdcall VslibCent2Freq( int cent );
VSLIB_IMPORT int __stdcall VslibFreq2Cent( double freq );
VSLIB_IMPORT double __stdcall VslibNoteNum2Freq( int noteNum );
VSLIB_IMPORT int __stdcall VslibFreq2NoteNum( double freq );

// ̑
VSLIB_IMPORT int __stdcall VslibSetPitchArray( HVSPRJ hVsprj, int itemNum, int *pitData, int nPitData, double interval );

// ASAnalyzer
VSLIB_IMPORT int __stdcall AS_GetDllVer( void );
VSLIB_IMPORT double __stdcall AS_Cent2Freq( int cent, double freqa4 );
VSLIB_IMPORT int __stdcall AS_Freq2Cent( double freq, double freqa4 );
VSLIB_IMPORT double __stdcall AS_Nnum2Freq( int nnum, double freqa4 );
VSLIB_IMPORT int __stdcall AS_Freq2Nnum( double freq, double freqa4 );

VSLIB_IMPORT int __stdcall AS_AnalyzeWaveData( void *wavdata, unsigned short sndspc[], int *pitch, int wavdatasize,
	int wavsampleps, int wavbit, int wavchannel, int nnoffset, int nnrange, int blockpn, int targetch, double freqa4 );
VSLIB_IMPORT int __stdcall AS_AnalyzeWaveDataEX( void *wavdata, unsigned short *sndspc,
	int *pitch, int *dynamics, AWDINFO *awdi, double freqa4 );
VSLIB_IMPORT int __stdcall AS_AnalyzeWaveFile( char *wavfile, char *txtfile, int blockps, int nnoffset, int nnrange );

#endif /* _VSLIB_H_ */
